﻿using System;
using System.Globalization;
using System.Windows.Data;

using DevExpress.Data.Filtering;

namespace TestProject
{
    /// <summary>
    /// 정수↔바이너리 연산자 값 변환자
    /// </summary>
    public class IntegerToBinaryOperatorValueConverter : IValueConverter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 변환하기 - Convert(value, targetType, parameter, cultureInfo)

        /// <summary>
        /// 변환하기
        /// </summary>
        /// <param name="value">값</param>
        /// <param name="targetType">타겟 타입</param>
        /// <param name="parameter">매개 변수</param>
        /// <param name="cultureInfo">CultureInfo 객체</param>
        /// <returns>변환 값</returns>
        public object Convert(object value, Type targetType, object parameter, CultureInfo cultureInfo)
        {
            BinaryOperator binaryOperator = value as BinaryOperator;

            if(object.ReferenceEquals(binaryOperator, null))
            {
                return null;
            }

            OperandValue operandValue = binaryOperator.RightOperand as OperandValue;

            return operandValue.Value;
        }

        #endregion
        #region 역변환하기 - ConvertBack(value, targetType, parameter, cultureInfo)

        /// <summary>
        /// 역변환하기
        /// </summary>
        /// <param name="value">값</param>
        /// <param name="targetType">타겟 타입</param>
        /// <param name="parameter">매개 변수</param>
        /// <param name="cultureInfo">CultureInfo 객체</param>
        /// <returns>역변환 값</returns>
        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo cultureInfo)
        {
            return new BinaryOperator("Index", System.Convert.ToInt32(value), BinaryOperatorType.Greater);
        }

        #endregion
    }
}